UOJ61. 【UR #5】怎样更有力气
Statement
给定一棵 \(n\) 点树 \(T\) 和 \(m\) 个操作 v u w :
- 在 \(T\) 中 \(u,v\) 的最短路上所有点里面选出若干对(可以不选,可以重复),在每一对之间加边,花费为 \(w\) .
- 有 \(p\) 个限制
t a b,表示第 \(t\) 次不能在 \(a,b\) 之间加边,保证 \(a,b\) 在 \(u,v\) 的路径上且无重复。
求所有加的边形成 \(n\) 点连通图的最小代价。 \(n,m,p\leq 3e5\) .
Solution
一开始看错题了
一个显然的想法是,把每一天按照 \(w\) 升序,然后每次尽可能多地合并连通块。
有一个显然的性质: 对于第 \(i\) 天,设当天有 \(num\) 个限制,如果 \(dis(u,v)>num\) ,那么这一条路径上的所有点之间都能连通,且必须连通
Proof
长度是 \(dis(u,v)\) ,点数就是 \(dis(u,v)+1\) .既然 \(dis(u,v)\) 比 \(num\) 大,那么就算一个点包揽了 \(num\) 个限制,也至少能向一个点连边,这样就一定可以使得路径上所有点连通。而由于我们是将每一次操作按 \(w\) 升序的,所以这一次将它连边一定不会比后面再做劣,因此这种情况下,第 \(i\) 次做完之后一定是 \(path(u,v)\) 全部连通。
那么对于满足这个性质的情况,直接连就好了,反正连完就是同一个连通块。(网上题解为啥说的是能直接连边啊……虽然是等价的)
现在来考虑 \(dis(u,v)\leq num\) 的情况。
首先,对于 \(t\) 的所有限制,建立一个子图 \(g\) ,并暴力把 \(u\to v\) 路径上的所有点都存下来,设为 \(path[]\) .令 \(t\) 的限制个数为 \(k\) .
然后,选取一个度数最小的点 \(x\) ,将路径上的点集分成两类:\(V_1\) 中的点在限制子图中和 \(x\) 相邻,\(V_2\) 反之。
显然,对于 \(V_2\) 的点,直接和 \(x\) 连边就好了。
对于 \(V_1\) 中的点 \(y\) ,如果 \(deg[y]<|V_2|\) (这里的度数是和 \(V_2\) 的度数),那么至少能和 \(V_2\) 中一个点连边,直接加边即可。复杂度 \(\mathcal{O}(\sum_y deg[y])=\mathcal{O}(k)\) .
否则,暴力枚举 \(V_1\) 中的点,尝试两两连边。由于度数最小所以 \(deg[x]\) 是根号级别的,复杂度 \(\mathcal{O}(k)\) .
所以总体复杂度是 \(\mathcal{O}(n\log n)\) (同级复杂度),瓶颈在于排序。
Code
//Author: RingweEH
const int N=3e5+10;
struct Date
{
int u,v,w,t;
bool operator < ( const Date &tmp ) const { return w<tmp.w; }
}a[N];
struct DSU
{
int fa[N];
int find( int x ) { return x==fa[x] ? x : fa[x]=find(fa[x]); }
DSU() { for ( int i=1; i<=N-10; i++ ) fa[i]=i; }
}D1,D2;
int n,m,k,fa[N],dep[N];
ll ans=0;
bool vis[N];
vector<Date> restr[N];
vector<int> g[N];
stack<Date> sta;
bool Check_Length( int u,int v,int num ) //判断dis(u,v)的长度和限制个数的大小关系
{
while ( num-- )
{
if ( dep[u]>dep[v] ) swap( u,v );
v=fa[v];
if ( u==v ) return 0;
}
return 1;
}
void Merge( int u,int v,int w )
{
u=D2.find( u ); v=D2.find( v );
if ( u!=v ) D2.fa[v]=u,ans+=w;
}
void Add( int u,int v )
{
g[u].push_back( v ); g[v].push_back( u );
Date tmp; tmp.u=u; tmp.v=v; tmp.w=tmp.t=0; sta.push( tmp );
}
void Clear( int u=0,int v=0 )
{
while ( !sta.empty() )
{
u=sta.top().u; v=sta.top().v; sta.pop();
g[u].clear(); g[v].clear();
}
}
int path[N],lenth;
void Get_Path( int u,int v )
{
lenth=0; bool fl=0;
do
{
fl=(u==v);
if ( dep[u]>dep[v] ) swap( u,v );
path[++lenth]=v; v=fa[v];
} while ( !fl );
}
int main()
{
n=read(); m=read(); k=read();
for ( int i=2; i<=n; i++ )
fa[i]=read(),dep[i]=dep[fa[i]]+1;
for ( int i=1; i<=m; i++ )
a[i].u=read(),a[i].v=read(),a[i].w=read(),a[i].t=i;
for ( int i=1,u,v,t; i<=k; i++ )
t=read(),u=read(),v=read(),restr[t].push_back( (Date){u,v,0,0} );
sort( a+1,a+1+m );
for ( int i=1; i<=m; i++ )
{
int u=a[i].u,v=a[i].v,w=a[i].w,t=a[i].t;
if ( Check_Length(u,v,restr[t].size()) ) //满足性质
{
u=D1.find( u ); v=D1.find( v );
while ( u^v )
{
if ( dep[u]>dep[v] ) swap( u,v );
Merge( v,fa[v],w ); D1.fa[v]=fa[v]; v=D1.find( v );
}
}
else
{
for ( Date j : restr[t] )
Add( j.u,j.v ); //对于限制建子图
Get_Path( u,v ); int mn=path[1];
for ( int j=2; j<=lenth; j++ ) //找度数最小的点
if ( g[path[j]].size()<g[mn].size() ) mn=path[j];
for ( int j : g[mn] ) //标记相邻点
vis[j]=1;
for ( int j=1; j<=lenth; j++ ) //x & V2
if ( !vis[path[j]] ) Merge( mn,path[j],w );
for ( int j : g[mn] )
{
int sum=0;
for ( int p : g[j] )
sum+=vis[p];
if ( g[j].size()-sum-1<lenth-g[mn].size()-1 ) Merge( j,mn,w );
//deg[y]<|V2|
}
for ( int j : g[mn] )
vis[j]=0;
for ( int j : g[mn] )
{
for ( int p : g[j] )
vis[p]=1;
for ( int p : g[mn] ) //V1中两两尝试连边
if ( !vis[p] ) Merge( j,p,w );
for ( int p : g[j] )
vis[p]=0;
}
Clear();
}
}
printf( "%lld\n",ans );
return 0;
}
UOJ61. 【UR #5】怎样更有力气的更多相关文章
- 【UOJ#61】【UR #5】怎样更有力气(最小生成树)
[UOJ#61][UR #5]怎样更有力气(最小生成树) 题面 UOJ 题解 最最最暴力的想法是把所有边给处理出来然后跑\(MST\). 考虑边权的情况,显然离线考虑,把么一天按照\(w_i\)进行排 ...
- 「UR#5」怎样更有力气
「UR#5」怎样更有力气 解题思路 考虑没有限制的情况,一定是把操作离线下来,按照边权从小到达做.可以发现,如果没有限制,完全图是多余的,直接拿树边进行合并就可以了.我们要做这么一件事情,把每个点属于 ...
- UOJ#61. 【UR #5】怎样更有力气
大力水手问禅师:“大师,很多事情都需要用很大力气才能完成,而我在吃了菠菜之后力气很大,于是就导致我现在非常依赖菠菜.我很讨厌我的现状,有没有办法少吃点菠菜甚至不吃菠菜却仍很有力气?” 禅师浅笑,答:“ ...
- YYHS-怎样更有力气
题目描述 OI大师抖儿在夺得银牌之后,顺利保送pku.这一天,抖儿问长者:"我虽然已经保送了,但我的志向是为国家健康工作五十年.请问我应该怎样变得更有力气?" 长者回答:&quo ...
- 【NOIP2017练习】怎样更有力气(二分答案,线性扫描)
题意:OI大师抖儿在夺得银牌之后,顺利保送pku.这一天,抖儿问长者:“我虽然已经保送了,但我的志向是为国家健康工作五十年.请问我应该怎样变得更有力气?” 长者回答:“你啊,Too Young T ...
- 【UR #5】怎样更有力气
Problem Description 大力水手问禅师:"大师,很多事情都需要用很大力气才能完成,而我在吃了菠菜之后力气很大,于是就导致我现在非常依赖菠菜.我很讨厌我的现状,有没有办法少吃点 ...
- [UOJ61]怎样更有力气
这个题还是挺有意思的... 一个小结论是:在一个$n$点$m$边的图中,如果度数最小的点度数为$d$,那么$d^2=O(m)$,因为$d\leq\frac{2m}n$,所以$d^2\leq dn\le ...
- 校际联合Contest
每次开一个坑都像是重新被碾压的预感 最近的新闻,以前很喜欢乔任梁的<复活>...然后他就死了...感觉我再多愁善感一点的话...就要悲伤逆流成河了吧... Contest 09/24(乐滋 ...
- 如何编写高质量的 jQuery 代码?
想必大家对于jQuery这个最流行的javascript类库都不陌生,而且只要是前端开发人员肯定或多或少的使用或者接触过,在今天的这篇文章中,我们将介绍一些书写高质量jQuery代码的原则,我们不单单 ...
随机推荐
- spring 2.5 基础知识和与其他框架的集成
spring环境搭建: 一:导入spring2.5所需的包,在classpath目录下建一个名为"beans.xml"模板文件: <?xml version="1. ...
- TCP/IP模型简介和/etc/hosts文件说明
软件=协议的实现. IP决定了主机的位置.端口号决定了进程的位置. 两台主机上的通讯实际是两台主机上两个具体进程的通讯. TCP/IP模型分四层: TCP/IP模型:应用层---传输层----网络层- ...
- eclipse 和 myeclipse 字符编码设置
需要设置的几处地方为: Window->Preferences->General ->Content Type 所有 Default encoding 设置为UTF-8 Window ...
- ATT&CK模型
Credential Dumping(凭证窃取) Dump credentials from LSASS(从LSASS中窃取凭证) 实现原理: This technique injects into ...
- 【老孟Flutter】自定义文本步进组件
交流 老孟Flutter博客(330个控件用法+实战入门系列文章):http://laomengit.com 欢迎加入Flutter交流群(微信:laomengit).关注公众号[老孟Flutter] ...
- 如何用ABBYY FineReader 识别表格
ABBYY FineReader有着强大的OCR文字识别功能,不但可以将文件转换为文本文档或Word文档,也可以识别PDF文件或者图片上的表格,并且转换为Excel文件. 下面小编就使用ABBYY F ...
- 如何使Camtasia的抠像效果更真实自然
相信大家都知道录像编辑软件Camtasia的"移除颜色"可以抠像换背景,详细操作可以看小编的另一篇教程 <如何用Camtasia为微课换上一个好看的背景>.接下来,小编 ...
- Centos7安装Nginx详细步骤
前言 Nginx 是一款轻量级的Web 服务器 .反向代理服务器及电子邮件(IMAP/POP3)代理服务器. 常用用途: ✓ 1. 反向代理 ✓ 2. 正向代理 这里我给来2张图,对正向代理与反响代理 ...
- asp.net core 集成 Prometheus
asp.net core 集成 prometheus Intro Prometheus 是一个开源的现代化,云原生的系统监控框架,并且可以轻松的集成 PushGateway, AlertManager ...
- sharding事务。
我们这么操作: 本地事务,但是会发现如果有异常两边都回滚了.看代码如下: rollback看一看: cachedConnections中缓存了2个connection. 对于每个connection调 ...